// unit Delfi_tapi
//
// component for calling phones using tapi32.dll that comes with win32
// based on Delphi devenloper support faq qestion : How can I use TAPI to dial the telephone for a voice call? 
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_tapi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TDelfi_tapi = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function Call(DestAddress,AppName,CalledParty,Comment: string): longint;
  published
    { Published declarations }
  end;

procedure Register;

implementation

{tapi Errors}
 const TAPIERR_CONNECTED          = 0;
 const TAPIERR_DROPPED            = -1;
 const TAPIERR_NOREQUESTRECIPIENT = -2;
 const TAPIERR_REQUESTQUEUEFULL   = -3;
 const TAPIERR_INVALDESTADDRESS   = -4;
 const TAPIERR_INVALWINDOWHANDLE  = -5;
 const TAPIERR_INVALDEVICECLASS   = -6;
 const TAPIERR_INVALDEVICEID      = -7;
 const TAPIERR_DEVICECLASSUNAVAIL = -8;
 const TAPIERR_DEVICEIDUNAVAIL    = -9;
 const TAPIERR_DEVICEINUSE        = -10;
 const TAPIERR_DESTBUSY           = -11;
 const TAPIERR_DESTNOANSWER       = -12;
 const TAPIERR_DESTUNAVAIL        = -13;
 const TAPIERR_UNKNOWNWINHANDLE   = -14;
 const TAPIERR_UNKNOWNREQUESTID   = -15;
 const TAPIERR_REQUESTFAILED      = -16;
 const TAPIERR_REQUESTCANCELLED   = -17;
 const TAPIERR_INVALPOINTER       = -18;

{tapi size constants}
 const TAPIMAXDESTADDRESSSIZE      = 80;
 const TAPIMAXAPPNAMESIZE          = 40;
 const TAPIMAXCALLEDPARTYSIZE      = 40;
 const TAPIMAXCOMMENTSIZE          = 80;
 const TAPIMAXDEVICECLASSSIZE      = 40;
 const TAPIMAXDEVICEIDSIZE         = 40;

function tapiRequestMakeCallA(DestAddress : PAnsiChar;
                              AppName : PAnsiChar;
                              CalledParty : PAnsiChar;
                              Comment : PAnsiChar) : LongInt;
  stdcall; external 'TAPI32.DLL';

function tapiRequestMakeCallW(DestAddress : PWideChar;
                              AppName : PWideChar;
                              CalledParty : PWideChar;
                              Comment : PWideChar) : LongInt;
  stdcall; external 'TAPI32.DLL';

function tapiRequestMakeCall(DestAddress : PChar;
                             AppName : PChar;
                             CalledParty : PChar;
                             Comment : PChar) : LongInt;
stdcall; external 'TAPI32.DLL';

function TDelfi_tapi.Call(DestAddress,AppName,CalledParty,Comment: string): longint;
begin
result:=tapiRequestMakeCall(pchar(DestAddress),pchar(AppName),pchar(CalledParty),pchar(Comment));
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_tapi]);
end;

end.
