// unit Trackbar_32
//
// improved ttrackbar with thin line instead rather big white space which the slider moves along
// and with additional properties and events : Enableselrange, onmousedown, onmouseup and onmousemove
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Trackbar_32;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, CommCtrl;

type
  TTrackbar_32 = class(TTrackBar)
  private
    { Private declarations }
    FEnableselrange:boolean;
    Fautohint:boolean;
    procedure SetEnableselrange(value:boolean);
    procedure Setautohint(value:boolean);
  protected
    { Protected declarations }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove (Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    { Public declarations }
  published
    { Published declarations }
    property Enableselrange:boolean read fEnableselrange write SetEnableselrange;
    property Autohint:boolean read fautohint write Setautohint;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property Color;
  end;

procedure Register;

implementation

procedure TTrackbar_32.SetEnableselrange(value:boolean);
begin
inherited;
FEnableselrange:=value;
recreatewnd;
end;

procedure TTrackbar_32.Setautohint(value:boolean);
begin
inherited;
Fautohint:=value;
recreatewnd;
end;

procedure TTrackbar_32.MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
try
inherited MouseDown (Button, Shift, X, Y);
except end;
end;

procedure TTrackbar_32.MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
try
inherited MouseUp (Button, Shift, X, Y);
except end;
end;

procedure TTrackbar_32.MouseMove (Shift: TShiftState; X, Y: Integer);
begin
inherited MouseMove (shift, X, Y);
end;

constructor TTrackbar_32.Create(AOwner: TComponent);
begin
inherited;
FEnableselrange:=false;
Color:=clbtnface;
end;

procedure TTrackbar_32.CreateParams(var Params: TCreateParams);
begin
inherited CreateParams(params);
if fEnableselrange = true then params.style:=params.style OR TBS_ENABLESELRANGE;
if fEnableselrange = false then params.style:=params.style AND NOT TBS_ENABLESELRANGE;
if fautohint = true then params.style:=params.style OR TBS_TOOLTIPS;
if fautohint = false then params.style:=params.style AND NOT TBS_TOOLTIPS;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TTrackbar_32]);
end;

end.
