// unit Delfi_ipedit
//
// standard windows ip edit control 
//
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_ipedit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Commctrl;

type
  TDelfi_ipedit = class(TCustomControl)
  private
    { Private declarations }
    ffont:tfont;
    procedure setfont(value:tfont);
    procedure setfirst(value:integer);
    procedure setsecond(value:integer);
    procedure setthird(value:integer);
    procedure setfourth(value:integer);
    function getfirst:integer;
    function getsecond:integer;
    function getthird:integer;
    function getfourth:integer;
  protected
    { Protected declarations }
    ipEdit:HWND;
    ipAddress:integer;
    ipinternal:integer;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Loaded; override;
    procedure clear;
  published
    { Published declarations }
    property font : tfont read ffont write Setfont;
    property first : integer read getfirst write Setfirst;
    property second : integer read getsecond write Setsecond;
    property third : integer read getthird write Setthird;
    property fourth : integer read getfourth write Setfourth;
  end;

procedure Register;

implementation

procedure TDelfi_ipedit.loaded;
begin
inherited;
//ipAddress:=MAKEIPADDRESS(0,0,0,0);
InitCommonControl(ICC_INTERNET_CLASSES);
ipEdit:=CreateWindow(WC_IPADDRESS,nil,WS_CHILD or WS_VISIBLE,0,0,130,23,self.Handle,0,hInstance,nil);
end;

procedure TDelfi_ipedit.WMSize(var Message: TWMSize);
begin
MoveWindow(ipEdit,0,0,width,height,true);
end;

constructor TDelfi_ipedit.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
height:=30;
width:=80;
end;

procedure TDelfi_ipedit.clear;
begin
SendMessage(ipEdit,IPM_CLEARADDRESS,0,0);
end;

procedure TDelfi_ipedit.setfont(value:tfont);
//var hfont : integer;
begin
ffont.assign(value);
(*hFont := CreateFont(-11, 0, 0, 0, 400, 0, 0, 0, DEFAULT_CHARSET,
OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
DEFAULT_PITCH or FF_DONTCARE, 'Arial');
if hFont <> 0 then
SendMessage(ipEdit, WM_SETFONT, hFont, 0);*)
ffont.assign(value);
end;

procedure TDelfi_ipedit.setfirst(value:integer);
begin
if value > 255 then value:=255;
ipinternal:=MAKEIPADDRESS(value,getsecond,getthird,getfourth);
SendMessage(ipEdit,IPM_SETADDRESS,0,ipinternal);
invalidate;
end;

procedure TDelfi_ipedit.setsecond(value:integer);
begin
if value > 255 then value:=255;
ipinternal:=MAKEIPADDRESS(getfirst,value,getthird,getfourth);
SendMessage(ipEdit,IPM_SETADDRESS,0,ipinternal);
invalidate;
end;

procedure TDelfi_ipedit.setthird(value:integer);
begin
if value > 255 then value:=255;
ipinternal:=MAKEIPADDRESS(getfirst,getsecond,value,getfourth);
SendMessage(ipEdit,IPM_SETADDRESS,0,ipinternal);
invalidate;
end;

procedure TDelfi_ipedit.setfourth(value:integer);
begin
if value > 255 then value:=255;
ipinternal:=MAKEIPADDRESS(getfirst,getsecond,getthird,value);
SendMessage(ipEdit,IPM_SETADDRESS,0,ipinternal);
invalidate;
end;

function TDelfi_ipedit.getfirst:integer;
var x:cardinal;
begin
SendMessage(ipEdit,IPM_GETADDRESS,0,longint(@x));
result:=FIRST_IPADDRESS(x);
end;

function TDelfi_ipedit.getsecond:integer;
var x:cardinal;
begin
SendMessage(ipEdit,IPM_GETADDRESS,0,longint(@x));
result:=second_IPADDRESS(x);
end;

function TDelfi_ipedit.getthird:integer;
var x:cardinal;
begin
SendMessage(ipEdit,IPM_GETADDRESS,0,longint(@x));
result:=third_IPADDRESS(x);
end;

function TDelfi_ipedit.getfourth:integer;
var x:cardinal;
begin
SendMessage(ipEdit,IPM_GETADDRESS,0,longint(@x));
result:=fourth_IPADDRESS(x);
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_ipedit]);
end;

end.
