// unit Delfi_oneapp
//
// a component that detects if there is more than one instance of your application
// it can terminate program if reqired 
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_oneapp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TDelfi_oneapp = class(TComponent)
  private
    { Private declarations }
    fterminate:boolean;
    got_another: TNotifyEvent;
    procedure Setterminate(Value: boolean);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Loaded; override;
  published
    { Published declarations }
    property terminate : boolean read fterminate write Setterminate;
    property on_got_another: TNotifyEvent read got_another write got_another;
  end;

procedure Register;

implementation

procedure TDelfi_oneapp.Setterminate(Value: boolean);
begin
fterminate:=Value;
end;

procedure TDelfi_oneapp.Loaded;
begin
if not (csDesigning in ComponentState) then begin
CreateMutex(nil, false, PChar(ExtractFileName(Application.ExeName)));
if GetLastError = ERROR_ALREADY_EXISTS then begin
if Assigned(got_another) then got_another(Self);
if fterminate = true then halt(0);
end;
end;
end;

constructor TDelfi_oneapp.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_oneapp]);
end;

end.
 
