// unit Delfi_stringparser
//
// simple stringparser that works like substring in html
// it can also search string inside other string
//
// version 1.0  2001 Delfi
//
// this component is freeware for non-commercial applications you use it on your own responsibility !
// you may modify this unit only for non-commercial applications
// you may not change the AUTHOR you must leave this comment here !
//
// if you improved this component add your comment after this line

unit Delfi_stringparser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TDelfi_stringparser = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  function substring(string_:string; start,length:integer): string;
  function findtext(string_,searchstring:string): integer;
  published
    { Published declarations }
  end;

procedure Register;

implementation

function TDelfi_stringparser.substring(string_:string; start,length:integer): string;
var edit_:tedit;
form_:tform;
begin
form_:=tform.Create(application);
edit_:=tedit.Create(form_);
edit_.parent:=form_;
edit_.Text:=string_;
edit_.SelStart:=start;
edit_.SelLength:=length;
result:=edit_.SelText;
edit_.Free;
form_.Free;
end;

function TDelfi_stringparser.findtext(string_,searchstring:string): integer;
var edit_:tRichEdit;
form_:tform;
FoundAt: LongInt;
StartPos, ToEnd: integer;
begin
form_:=tform.Create(application);
edit_:=tRichEdit.Create(form_);
edit_.parent:=form_;
edit_.Lines.Clear;
edit_.Lines.Add(string_);

with edit_ do
begin
if SelLength <> 0 then
StartPos := SelStart + SelLength
else
StartPos := 0;
ToEnd := Length(Text) - StartPos;
FoundAt := FindText({}searchstring, StartPos, ToEnd, [stMatchCase]);
if FoundAt <> -1 then
begin
result:=FoundAt;
//showmessage(inttostr(Length('456')));
end;
end;
edit_.Free;
form_.Free;
end;

procedure Register;
begin
  RegisterComponents('Delfi', [TDelfi_stringparser]);
end;

end.
 
